Attribute VB_Name = "basCstDr"
'=========================================================================
'   ݁`ppAPITv
'-------------------------------------------------------------------------
'   [RRg[] Xgr[̃JX^h[
'-------------------------------------------------------------------------
'   [쐬]    2000N0711
'-------------------------------------------------------------------------
'   [NOTES]
'   VB5 Microsoft Common Controls 5.0 (SP2) gpTvłB
'   (VB6p\)
'=========================================================================
Option Explicit

'//==================== WIN32 API ========================================

Public Const WM_NOTIFY = &H4E
Public Const GWL_WNDPROC = -4

Public Type NMHDR
    hwndFrom    As Long
    idfrom      As Long
    code        As Long
End Type

Public Type RECT
    Left        As Long
    Top         As Long
    Right       As Long
    Bottom      As Long
End Type

Public Type POINTAPI
    x           As Long
    y           As Long
End Type

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)


'//==================== COMMON CONTROLS API ===================================

Public Const NM_FIRST = 0&
Public Const NM_CUSTOMDRAW = (NM_FIRST - 12)

Public Const LVS_EX_FULLROWSELECT = &H20
Public Const LVS_EX_CHECKBOXES = &H4

Public Const LVM_FIRST = &H1000
Public Const LVM_SETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 54)
Public Const LVM_APPROXIMATEVIEWRECT = (LVM_FIRST + 64)


Public Type NMLISTVIEW
    hdr         As NMHDR
    iItem       As Long
    iSubItem    As Long
    uNewState   As Long
    uOldState   As Long
    uChanged    As Long
    ptAction    As POINTAPI
    lParam      As Long
End Type

'//==================== CUSTOM DRAW ==========================================

'// custom draw return flags
'// values under =&H00010000 are reserved for global custom draw values.
'// above that are for specific controls
Public Const CDRF_DODEFAULT = &H0
Public Const CDRF_NEWFONT = &H2
Public Const CDRF_SKIPDEFAULT = &H4


Public Const CDRF_NOTIFYPOSTPAINT = &H10
Public Const CDRF_NOTIFYITEMDRAW = &H20
Public Const CDRF_NOTIFYSUBITEMDRAW = &H20         '// flags are the same, we can distinguish by context
Public Const CDRF_NOTIFYPOSTERASE = &H40

'// drawstage flags
'// values under =&H00010000 are reserved for global custom draw values.
'// above that are for specific controls
Public Const CDDS_PREPAINT = &H1
Public Const CDDS_POSTPAINT = &H2
Public Const CDDS_PREERASE = &H3
Public Const CDDS_POSTERASE = &H4
'// the =&H000010000 bit means it's individual item specific
Public Const CDDS_ITEM = &H10000
Public Const CDDS_ITEMPREPAINT = (CDDS_ITEM Or CDDS_PREPAINT)
Public Const CDDS_ITEMPOSTPAINT = (CDDS_ITEM Or CDDS_POSTPAINT)
Public Const CDDS_ITEMPREERASE = (CDDS_ITEM Or CDDS_PREERASE)
Public Const CDDS_ITEMPOSTERASE = (CDDS_ITEM Or CDDS_POSTERASE)
Public Const CDDS_SUBITEM = &H20000

'// itemState flags
Public Const CDIS_SELECTED = &H1
Public Const CDIS_GRAYED = &H2
Public Const CDIS_DISABLED = &H4
Public Const CDIS_CHECKED = &H8
Public Const CDIS_FOCUS = &H10
Public Const CDIS_DEFAULT = &H20
Public Const CDIS_HOT = &H40
Public Const CDIS_MARKED = &H80
Public Const CDIS_INDETERMINATE = &H100

Public Type NMCUSTOMDRAWINFO
    hdr         As NMHDR
    dwDrawStage As Long
    hdc         As Long
    rc          As RECT
    dwItemSpec  As Long
    uItemState  As Long
    lItemlParam As Long
End Type

Public Type NMLVCUSTOMDRAW
    nmcd        As NMCUSTOMDRAWINFO
    clrText     As Long
    clrTextBk   As Long
    iSubItem    As Long
End Type

Private lpProcOrg   As Long

Public Function ListView_SetExtendedListViewStyle(ByVal hwndLV As Long, ByVal ExStyle As Long) As Long
    ListView_SetExtendedListViewStyle = SendMessage(hwndLV, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, ByVal ExStyle)
End Function
        
Public Function ListView_ApproximateViewRect(ByVal hwndLV As Long, ByVal iWidth As Integer, ByVal iHeight As Integer, ByVal iCount As Long) As Long
        ListView_ApproximateViewRect = SendMessage(hwndLV, LVM_APPROXIMATEVIEWRECT, iCount, ByVal MAKELPARAM(iWidth, iHeight))
End Function

Public Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
    Dim udtNMHdr    As NMHDR
    Dim udtNMLvw    As NMLISTVIEW
    Dim udtCdLvw    As NMLVCUSTOMDRAW
    Dim blnNoCall   As Boolean
    Dim lngForeColor    As Long
    Dim lngBackColor    As Long
    
    Select Case uMsg
        
    Case WM_NOTIFY
        
        CopyMemory udtNMHdr, ByVal lParam, LenB(udtNMHdr)
        
        If udtNMHdr.hwndFrom = frmCstDr.ListView1.hwnd Then
            
            CopyMemory udtNMLvw, ByVal lParam, LenB(udtNMLvw)
            
            If udtNMLvw.hdr.code = NM_CUSTOMDRAW Then
                
                CopyMemory udtCdLvw, ByVal lParam, LenB(udtCdLvw)
                
                Select Case udtCdLvw.nmcd.dwDrawStage
                '-- Gloval Values
                Case CDDS_POSTERASE     ' After the erasing cycle is complete.
                Case CDDS_POSTPAINT     ' After the painting cycle is complete.
                Case CDDS_PREERASE      ' Before the erasing cycle begins.
                Case CDDS_PREPAINT      ' Before the painting cycle begins.
                    WindowProc = CDRF_NOTIFYITEMDRAW
                '-- Item-specific Values
                Case CDDS_ITEMPREPAINT
                    
                    '-- obNJ[ɉFƐF݂ɐݒ肷
                    If udtCdLvw.nmcd.dwItemSpec Mod 2 Then
                        lngForeColor = vbWhite
                        lngBackColor = RGB(58, 110, 165)
                    Else
                        lngForeColor = vbBlack
                        lngBackColor = RGB(255, 255, 192)
                    End If
                    udtCdLvw.clrTextBk = lngBackColor
                    udtCdLvw.clrText = lngForeColor
                                        
                    'udtCdLvw.nmcd.hdcgpGDInAPIɂ`揈sƂ
                    
                    'w肵e𔽉f
                    CopyMemory ByVal lParam, udtCdLvw, LenB(udtCdLvw)
                    
                End Select
                
            End If
        End If
    
    Case Else
    
    End Select
    If WindowProc = 0& Then
        WindowProc = CallWindowProc(lpProcOrg, hwnd, uMsg, wParam, lParam)
    End If
    
End Function

Public Sub SubClass(ByVal hwnd As Long)
    lpProcOrg = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf WindowProc)
End Sub

Public Sub UnSubClass(ByVal hwnd As Long)
    Dim lngRet  As Long
    lngRet = SetWindowLong(hwnd, GWL_WNDPROC, lpProcOrg)
End Sub

Public Function LOWORD(dwValue As Long) As Integer
    Dim intVal  As Integer
    CopyMemory intVal, dwValue, 2
    LOWORD = intVal
End Function

Public Function HIWORD(dwValue As Long) As Integer
    Dim intVal  As Integer
    CopyMemory intVal, ByVal VarPtr(dwValue) + 2, 2
    HIWORD = intVal
End Function

Public Function MAKELPARAM(ByVal wLow As Integer, ByVal wHigh As Integer) As Long
    MAKELPARAM = (CLng(wLow) * 2 ^ 16) + CLng(wHigh)
End Function
